/***************************************************************************
 $RCSfile: aqmconverter.h,v $
                             -------------------
    cvs         : $Id: aqmconverter.h,v 1.1 2003/05/29 15:37:48 aquamaniac Exp $
    begin       : Sat May 17 2003
    copyright   : (C) 2003 by Martin Preuss
    email       : martin@aquamaniac.de
*/

/***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston,                 *
 *   MA  02111-1307  USA                                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef CONVERTER_H
#define CONVERTER_H


#include <openhbci.h>
#include "aqmtypes.h"
#include <list>
#include <stdio.h>

using namespace std;
using namespace HBCI;



/**
 * This is a generic converter class.
 * @author Martin Preuss<martin@libchipcard.de>
 */
class AQMConverter {
private:
  list<AQMTransaction> _xactions;
public:
  AQMConverter();
  virtual ~AQMConverter();

  virtual Error readFromStream(HBCI::Pointer<Stream> s);
  virtual Error writeToStream(HBCI::Pointer<Stream> s);

  void clear();
  void addTransaction(const AQMTransaction &xa);
  void setTransactions(const list<AQMTransaction> &t) { _xactions=t;};
  const list<AQMTransaction> &transactions() const { return _xactions;};
};


#endif

